"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.register = void 0;

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _path = _interopRequireDefault(require("path"));

var _fs = _interopRequireDefault(require("fs"));

var _graphql = require("graphql");

var _graphqlTypeJson = _interopRequireDefault(require("graphql-type-json"));

var _hooks = require("@forrestjs/service-express/hooks");

// @TODO: let a configuration to tell where to fetch the locale files
var loadLocaleFile = function loadLocaleFile(locale) {
  return new Promise(function (resolve, reject) {
    var origin = process.env.NODE_ENV === 'production' ? 'build-src' : 'src';

    var filePath = _path["default"].join(process.cwd(), origin, 'locale', locale.toLowerCase() + ".json");

    _fs["default"].readFile(filePath, 'utf8', function (err, data) {
      return err ? reject(err) : resolve(data);
    });
  });
};

var loadMessages =
/*#__PURE__*/
function () {
  var _ref = (0, _asyncToGenerator2["default"])(
  /*#__PURE__*/
  _regenerator["default"].mark(function _callee(locale) {
    var data;
    return _regenerator["default"].wrap(function _callee$(_context) {
      while (1) {
        switch (_context.prev = _context.next) {
          case 0:
            data = null; // try specific language "en_GB"

            _context.prev = 1;
            _context.next = 4;
            return loadLocaleFile(locale);

          case 4:
            data = _context.sent;
            _context.next = 9;
            break;

          case 7:
            _context.prev = 7;
            _context.t0 = _context["catch"](1);

          case 9:
            _context.prev = 9;
            _context.next = 12;
            return loadLocaleFile(locale.split('_').shift());

          case 12:
            data = _context.sent;
            _context.next = 18;
            break;

          case 15:
            _context.prev = 15;
            _context.t1 = _context["catch"](9);
            throw new Error("localization \"" + locale + "\" not available");

          case 18:
            _context.prev = 18;
            return _context.abrupt("return", JSON.parse(data));

          case 22:
            _context.prev = 22;
            _context.t2 = _context["catch"](18);
            throw new Error("localization \"" + locale + "\" is corrupted");

          case 25:
          case "end":
            return _context.stop();
        }
      }
    }, _callee, null, [[1, 7], [9, 15], [18, 22]]);
  }));

  return function loadMessages(_x) {
    return _ref.apply(this, arguments);
  };
}();

var localeQuery = {
  description: 'Provides localized messages',
  args: {
    locale: {
      type: new _graphql.GraphQLNonNull(_graphql.GraphQLString)
    }
  },
  type: new _graphql.GraphQLNonNull(new _graphql.GraphQLObjectType({
    name: 'Locale',
    fields: {
      locale: {
        type: new _graphql.GraphQLNonNull(_graphql.GraphQLString)
      },
      messages: {
        type: _graphqlTypeJson["default"]
      }
    }
  })),
  resolve: function () {
    var _resolve = (0, _asyncToGenerator2["default"])(
    /*#__PURE__*/
    _regenerator["default"].mark(function _callee2(params, args) {
      return _regenerator["default"].wrap(function _callee2$(_context2) {
        while (1) {
          switch (_context2.prev = _context2.next) {
            case 0:
              _context2.t0 = args.locale;
              _context2.next = 3;
              return loadMessages(args.locale);

            case 3:
              _context2.t1 = _context2.sent;
              return _context2.abrupt("return", {
                locale: _context2.t0,
                messages: _context2.t1
              });

            case 5:
            case "end":
              return _context2.stop();
          }
        }
      }, _callee2);
    }));

    function resolve(_x2, _x3) {
      return _resolve.apply(this, arguments);
    }

    return resolve;
  }()
};

var register = function register(_ref2) {
  var registerAction = _ref2.registerAction;
  return registerAction({
    hook: _hooks.EXPRESS_GRAPHQL,
    name: '▶ locale',
    handler: function handler(_ref3) {
      var queries = _ref3.queries;
      queries.locale = localeQuery;
    }
  });
};

exports.register = register;